
      SUBROUTINE CONIC2 (A,E,AI,O,W,EM,GMU,X)
      IMPLICIT DOUBLE PRECISION(A-H,O-Z)
      INTEGER DOUBLE,REAL
      PARAMETER(DOUBLE=1,REAL=0)

C     SOFTWARE ORIGINALLY WRITTEN BY RONALD J. BOAIN
C     SOFTWARE MAINTAINED BY R. STEPHEN SCHLAIFER
C     ********************WARNING**********************
C     DO NOT TRANSFER THIS SOFTWARE TO ANY INDIVIDUAL
C     OR INSTITUTION WITHOUT WRITTEN PERMISSION FROM

C             MISSION ANALYSIS SECTION (312)
C               JET PROPULSION LABORATORY
C          CALIFORNIA INSTITUTE OF TECHNOLOGY
C                 4800 OAK GROVE DRIVE
C             PASADENA, CALIFORNIA  91103
C                    (213) 354-4321

C                      2 MAY 1980

C *CONIC CONVERTS A CARTESIAN STATE INTO A SET OF KEPLERIAN ELEMENTS
C *ALL ANGLES ARE OUTPUT IN RADIANS

      DIMENSION X(6), HH(3), EE(3), TV(3)
      COMMON /CONDAT/ PV(3),QV(3),WV(3),RM,VM,RDOTV,H,P,ECC,FCC,TRUEA,BE
     1TA
      DIMENSION UX(3), UY(3), UZ(3)
      DATA UX /1.D0,0.D0,0.D0/ UY /0.D0,1.D0,0.D0/ UZ /0.D0,0.D0,1.D0/
      DATA PI /3.14159265358979324D0/ TPI /6.28318530717958648D0/
      DATA RPD /.0174532925199433D0/
      DATA DPR /57.29577951308232088D0/ PIH /1.57079632679489662D0/
      DATA SPD /86400.D0/

      IF(GMU.LE.0.)CALL ERROR('CONIC: GM < 0')
      A=0.
      E=0.
      AI=0.
      O=0.
      W=0.
      EM=0.
      ZERO=0.
      CALL VEQUAL(PV,UX,3)
      CALL VEQUAL(QV,UY,3)
      CALL VEQUAL(WV,UZ,3)
      RM=ABSV(X(1),3)
      VM=ABSV(X(4),3)
      RDOTV=DOT(X(1),X(4),3)
      H=0.
      P=0.
      ECC=0.
      FCC=0.
      TRUEA=0.
      BETA=0.
      IF (RM.LE.0.) CALL ERROR ('CONIC: RADIUS VECTOR HAS 0 MAGNITUDE')
      ALPHA=(2.0*GMU-RM*VM**2)/RM/GMU
      IF (ALPHA.NE.0.) A=1.0/ALPHA
      CALL VCROSS (HH,X(1),X(4))
      H=ABSV(HH,3)
      P=H**2/GMU
      IF (H.GT.0.) THEN
      CALL VUNIT (WV,HH,3)
      AI=ACOS(WV(3))
      CALL VCROSS (TV,X(4),HH)
      CALL VCOMB (EE,TV,1.0/GMU,X(1),-1.0/RM,3)
      E=ABSV(EE,3)
      IF (E.GT.0.) THEN
          CALL VUNIT (PV,EE,3)
      ELSEIF (ABS(WV(3)).LE.1.0) THEN
            CALL VEQUAL(TV,UZ,3)
          CALL VCROSS (PV,TV,WV)
      ENDIF
      CALL VCROSS (QV,WV,PV)
      IF (ABS(WV(3)).LT.1.0) O=ATAN3(WV(1),-WV(2),ZERO)
      IF (O.LT.0.) O=O+TPI
      IF(E.GT.0.) THEN
      W=ATAN3(PV(2),PV(1),ZERO)
          W=ATAN3(PV(3),QV(3),W)
      ENDIF
      IF (W.LT.0.) W=W+TPI
      STH=H*RDOTV/RM
      CTH=H*H/RM-GMU
      TRUEA=ATAN3(STH,CTH,ZERO)
      IF (TRUEA.LT.0.) TRUEA=TRUEA+TPI
      BETA=ACOS(RDOTV/RM/VM)
      IF (A.GT.0) THEN
C           ! ***ELLIPSE
          SQE=SQRT((1.0-E)/(1.0+E))
          ECC=2.0*ATAN(SQE*TAN(TRUEA/2.0))
          IF (ECC.LT.0.) ECC=ECC+TPI
          EM=ECC-E*SIN(ECC)
      ELSEIF (A.EQ.0) THEN
C           ! PARABOLA
          ECC=SQRT(P)*TAN(TRUEA/2.0)
          EM=(ECC**3+3.0*P*ECC)/6.0
      ELSE
C           ! HYPERBOLA
          SQE=SQRT((E-1.0)/(E+1.0))
          TANHF2=SQE*TAN(TRUEA/2.0)
          FCC=2.0*ATANH(TANHF2)
          EM=E*SINH(FCC)-FCC
      ENDIF
      ELSE
      O=ATAN3(X(2),X(1),ZERO)
      IF (O.LT.0.) O=O+TPI
      AI=ASIN(X(3)/RM)
      IF (AI.LT.0.) AI=AI+PI
      E=1.0
      ENDIF


	return

	end
