
      SUBROUTINE GET_STAT( OUTUNIT, STAFILE, STNAME, STTYPE, STLAT, 
     1  STLONG, STX, STY, STZ, STZALIM1, STZALIM2,  STHALIM, 
     2  STDIAM, STSLEW1, STSLEW2, STBAND_NAME, STBAND_TSYS, 
     3  STBAND_EFFIC, STBAND_TSYSJY, AEIOWMORB, YEARORB, MNTHORB, 
     4  DAYORB, UTORB, TELEDIR, TELANGLE, SUNAVOID, ANTISUNAVOID, 
     5  MOONAVOID, ECLIPMULT, ECLIPADD, STNARRAY, STARRAY_NAME, 
     6  STTAPETYPE_NAME, IER, NST_IN, STNAME_IN, st_init)
C                         
C-----------------------------------------------------------------------
C Read the (new-format) stations file, store it, and use it to find
C station parameters by station name
C-----------------------------------------------------------------------
C                         
      IMPLICIT NONE
C                         
      INCLUDE 'svlbsched.inc'
C                         
      CHARACTER*(*) STAFILE
      CHARACTER*2 STBAND_NAME(NSTBANDMAX)
      CHARACTER*8 STNAME, STARRAY_NAME(NARRAYMAX)
      CHARACTER*8 STTAPETYPE_NAME(NSTTAPETYPEMAX)
      INTEGER OUTUNIT, STTYPE, YEARORB, MNTHORB, DAYORB, STNARRAY
      INTEGER IER, NST_IN
      DOUBLE PRECISION STLAT, STLONG, STX, STY, STZ, STZALIM1, STZALIM2 
      DOUBLE PRECISION STHALIM, STDIAM, STSLEW1, STSLEW2 
      DOUBLE PRECISION STBAND_TSYS(NSTBANDMAX) 
      DOUBLE PRECISION STBAND_EFFIC(NSTBANDMAX) 
      DOUBLE PRECISION STBAND_TSYSJY(NSTBANDMAX) 
      DOUBLE PRECISION AEIOWMORB(6), UTORB, TELEDIR(3), TELANGLE 
      DOUBLE PRECISION SUNAVOID(NSUNAVOIDMAX), ANTISUNAVOID, MOONAVOID
      DOUBLE PRECISION ECLIPMULT, ECLIPADD
C                         
      INTEGER NPARS, NSTMAX, NALIASMAX, NALIASMAX1
      PARAMETER  (NALIASMAX=10)
      PARAMETER  (NSTMAX=200)
      PARAMETER  (NALIASMAX1=NALIASMAX-1)
      PARAMETER  (NPARS=45+NALIASMAX+4*NSTBANDMAX+NARRAYMAX+
     1  NSTTAPETYPEMAX+NSUNAVOIDMAX)
C 
      CHARACTER*8 STNAME_IN(NSTMAX)
                        
      LOGICAL FIRST_TIME
      CHARACTER*80 PRINT_NAME
      CHARACTER*255 MESSAGE
      INTEGER VLBOPE, ISTUNIT, IELEM, ISTBAND, IPARS, MODE, IST, NST
      INTEGER IALIAS, NALIAS, LEN1, LSTAFILE, IARRAY, ITAPETYPE
C                         
      CHARACTER*8 ST_NAME(NALIASMAX,NSTMAX)
      CHARACTER*8 ST_ARRAY_NAME(NARRAYMAX,NSTMAX)
      CHARACTER*8 ST_TAPETYPE_NAME(NSTTAPETYPEMAX,NSTMAX)
      CHARACTER*8 ST_BAND_NAME(NSTBANDMAX,NSTMAX), STNAME_UPCASE
      INTEGER ST_TYPE(NSTMAX), ST_YEARORB(NSTMAX), ST_NALIAS(NSTMAX)
      INTEGER ST_MNTHORB(NSTMAX), ST_DAYORB(NSTMAX)
      INTEGER ST_NARRAY(NSTMAX)
      DOUBLE PRECISION ST_LAT(NSTMAX), ST_LONG(NSTMAX)
      DOUBLE PRECISION ST_X(NSTMAX), ST_Y(NSTMAX), ST_Z(NSTMAX)
      DOUBLE PRECISION ST_ZALIM1(NSTMAX), ST_ZALIM2(NSTMAX)
      DOUBLE PRECISION ST_HALIM(NSTMAX), ST_DIAM(NSTMAX)
      DOUBLE PRECISION ST_SLEW1(NSTMAX), ST_SLEW2(NSTMAX)
      DOUBLE PRECISION ST_BAND_TSYS(NSTBANDMAX,NSTMAX)
      DOUBLE PRECISION ST_BAND_EFFIC(NSTBANDMAX,NSTMAX)
      DOUBLE PRECISION ST_BAND_TSYSJY(NSTBANDMAX,NSTMAX)
      DOUBLE PRECISION ST_AEIOWMORB(6,NSTMAX), ST_UTORB(NSTMAX) 
      DOUBLE PRECISION ST_TELEDIR(3,NSTMAX), ST_TELANGLE(NSTMAX)
      DOUBLE PRECISION ST_SUNAVOID(NSUNAVOIDMAX,NSTMAX), ST_ANTISUNAVOID(NSTMAX)
      DOUBLE PRECISION ST_MOONAVOID(NSTMAX),ST_ECLIPMULT(NSTMAX), ST_ECLIPADD(NSTMAX)
      DOUBLE PRECISION RADIUS, LAT, CLAT, SLAT, LONG, CLONG, SLONG
      DOUBLE PRECISION X, Y, Z, RPROJ
C    

      logical st_init
      integer i

                     
      SAVE NST, FIRST_TIME
C VP add save for ST_NALIAS
      SAVE ST_NALIAS
      SAVE ST_NAME, ST_BAND_NAME, ST_TYPE, ST_YEARORB, ST_MNTHORB
      SAVE ST_DAYORB, ST_LAT, ST_LONG, ST_X, ST_Y, ST_Z, ST_ZALIM1
      SAVE ST_ZALIM2, ST_HALIM, ST_DIAM, ST_SLEW1, ST_SLEW2
      SAVE ST_BAND_TSYS, ST_BAND_EFFIC, ST_BAND_TSYSJY, ST_AEIOWMORB
      SAVE ST_UTORB, ST_TELEDIR, ST_TELANGLE, ST_SUNAVOID
      SAVE ST_ANTISUNAVOID, ST_MOONAVOID, ST_ECLIPMULT, ST_ECLIPADD, ST_NARRAY
      SAVE ST_ARRAY_NAME,ST_TAPETYPE_NAME
C                         
      DOUBLE PRECISION PARS(NPARS), VALS0(NPARS), VALS(NPARS), ENDMRK  
      CHARACTER*8 PARSCH0(NPARS) 
       
      SAVE PARS, VALS0,PARSCH0
      
C<<      DATA PARS /NALIASMAX*'STAtion', 'STCode', 'CONtrol', 'Elev', 
C<<     1  'LAT', 'LONG', 'HALim', 2*'ZALim', 'ENDCAT', 'X', 'Y', 'Z', 
C<<     2  'DEScrip', 9*' ', 'NDRIVES', 'TYPE', 'DIAMeter', 'RATE1', 
C<<     3  'RATE2', NSTBANDMAX*'BANDs', NSTBANDMAX*'TSYS', 
C<<     4  NSTBANDMAX*'EFFicien', NSTBANDMAX*'TSYSJY', 
C<<     5  6*'AEIOWM', 3*'DATEorb', 'UTorb', 
C<<     6  3*'TELEDIR', 'TELANgle', NSUNAVOIDMAX*'SUNAVOID', 'ANTISUN', 
C<<     7  'MOONAVOI', 'ECLIPMULT','ECLIPADD',
C<<     8  NARRAYMAX*'ARRAY', NSTTAPETYPEMAX*'OUTPUTS'/
C VP ERROR 9 chars in ECLIPMULT
     
    
	EQUIVALENCE (PARS,PARSCH0)
C ***********NEXT initialization ************

	DATA (PARSCH0(i), i=1, 10), 
     R PARSCH0(11),  PARSCH0(12),  PARSCH0(13), 
     R  PARSCH0(14),  PARSCH0(15),  PARSCH0(16), 
     R  (PARSCH0(i), i=17, 18), 
     R PARSCH0(19),  PARSCH0(20),  PARSCH0(21), 
     R  PARSCH0(22),  PARSCH0(23),  (PARSCH0(i), 
     R i=24, 32), PARSCH0(33), 
     R  PARSCH0(34),  PARSCH0(35),  PARSCH0(36), 
     R  PARSCH0(37),  (PARSCH0(i), i=38, 
     R 47), (PARSCH0(i), i=48, 
     R 57), (PARSCH0(i), i=58, 
     R 67), (PARSCH0(i), i=68, 
     R 77), (PARSCH0(i), i=78, 
     R 83), (PARSCH0(i), i=84, 
     R 86), PARSCH0(87),  (PARSCH0(i), 
     R i=88, 90), PARSCH0(91), 
     R  (PARSCH0(i), i=92, 101), 
     R PARSCH0(102),  PARSCH0(103),  PARSCH0(104), 
     R  PARSCH0(105),  (PARSCH0(i), i=106, 
     R 112), (PARSCH0(i), i=113, 
     R 122) 
     R /NALIASMAX*'STAtion',  'STCode',   'CONtrol', 
     R   'Elev',     'LAT',   'LONG', 
     R   'HALim',  2*'ZALim',  'ENDCAT', 
     R   'X',   'Y',   'Z', 
     R     'DEScrip',  9*' ',  'NDRIVES', 
     R   'TYPE',   'DIAMeter',   'RATE1', 
     R     'RATE2',  NSTBANDMAX*'BANDs', NSTBANDMAX*'TSYS', 
     R NSTBANDMAX*'EFFicien', NSTBANDMAX*'TSYSJY', 6*'AEIOWM', 
     R 3*'DATEorb',  'UTorb',  3*'TELEDIR', 
     R  'TELANgle',  NSUNAVOIDMAX*'SUNAVOID',  'ANTISUN', 
     R     'MOONAVOI',   'ECLIPMULT',  'ECLIPADD', 
     R  NARRAYMAX*'ARRAY', NSTTAPETYPEMAX*'OUTPUTS' /
C ***********NEXT initialization ************


	CHARACTER*8 ENDMRKCH0
	EQUIVALENCE (ENDMRK,ENDMRKCH0)
        DATA ENDMRKCH0/'/'/

C                         
      DATA ISTUNIT/15/, FIRST_TIME/.TRUE./
C                         
 6000 FORMAT (' Reading stations from ',A,' . . .')
 6010 FORMAT (/'+++ Warning +++ Too many stations in file ',A,/,
     1  'Will only work with the first',I4,/)

! force re-reading of stations.cat file if required

      if(st_init) FIRST_TIME = .true.

C                         
      IF (FIRST_TIME) THEN
         STAFILE = 'stations.cat'
        IER = VLBOPE( ISTUNIT, STAFILE, 'TEXT', 'OLD', MESSAGE )
        IF ( IER .EQ. 0 ) THEN
          CALL PUTOUT( MESSAGE )
          PRINT_NAME = STAFILE
          CALL ERROR('Cannot open stations catalog: '//PRINT_NAME//'  ')
        END IF
        LSTAFILE = LEN1(STAFILE)
C                         
        IST = 0
        MODE = 0 
! take out this write statement DWM 5-Dec-94
!       WRITE(OUTUNIT, 6000) STAFILE(1:LSTAFILE)
        DO WHILE (MODE .EQ. 0)
          DO IPARS=1,NPARS
             VALS(IPARS) = VALS0(IPARS)
          END DO
          CALL KEYIN(PARS,VALS,NPARS,ENDMRK,MODE,ISTUNIT,OUTUNIT)
C                         
          IST = IST + 1
          IF (IST .GT. NSTMAX) THEN
            WRITE(OUTUNIT, 6010) STAFILE(1:LSTAFILE), NSTMAX
            GO TO 20
          END IF
          NALIAS = 0
          DO IALIAS=1,NALIASMAX
            WRITE (ST_NAME(IALIAS,IST), '(A8)') VALS(IALIAS)
            IF (ST_NAME(IALIAS,IST) .EQ. ' ') GO TO 5
            CALL UPCASE(ST_NAME(IALIAS,IST))

	    IF(IALIAS.EQ.1) THEN
	     STNAME_IN(IST)=ST_NAME(IALIAS,IST)
	    END IF

            NALIAS = IALIAS
          END DO
    5     CONTINUE
          ST_NALIAS(IST) = NALIAS
          RADIUS = VALS(3+NALIASMAX)
          LAT = VALS(4+NALIASMAX)/3600D0
          IF (RADIUS .LT. 1D6) CALL GEOID(RADIUS,LAT)
          CLAT = DCOS(LAT*RPDEG)
          SLAT = DSIN(LAT*RPDEG)
          LONG = VALS(5+NALIASMAX)/3600D0
          CLONG = DCOS(LONG*RPDEG)
          SLONG = DSIN(LONG*RPDEG)
          X = VALS(10+NALIASMAX)
          Y = VALS(11+NALIASMAX)
          Z = VALS(12+NALIASMAX)
          IF ( (X.EQ.0D0) .AND. (Y.EQ.0D0) .AND.  (Z.EQ.0D0) ) THEN
            X = RADIUS*CLAT*CLONG
            Y = RADIUS*CLAT*SLONG
            Z = RADIUS*SLAT
          END IF
          RPROJ = DSQRT(X*X + Y*Y)
          ST_LAT(IST) = DEGPR*DATAN2(Z,RPROJ)
          ST_LONG(IST) = DEGPR*DATAN2(Y,X)
          ST_HALIM(IST) = VALS(6+NALIASMAX)
          ST_ZALIM1(IST) = VALS(7+NALIASMAX)
          ST_ZALIM2(IST) = VALS(8+NALIASMAX)
          ST_X(IST) = X
          ST_Y(IST) = Y
          ST_Z(IST) = Z
          ST_TYPE(IST) = VALS(24+NALIASMAX)
!          write(*,*) 'ST_TYPE:', ST_TYPE(IST), ' IST=',IST
!         IF (ST_TYPE(IST) .LE. 0D0) ST_TYPE(IST) = 1D0
          ST_DIAM(IST) = VALS(25+NALIASMAX)
          ST_SLEW1(IST) = VALS(26+NALIASMAX)
          ST_SLEW2(IST) = VALS(27+NALIASMAX)
          DO ISTBAND=1,NSTBANDMAX
            WRITE(ST_BAND_NAME(ISTBAND,IST), '(A2)') 
     1        VALS(27+NALIASMAX+ISTBAND)
            ST_BAND_TSYS(ISTBAND,IST) = 
     1        VALS(27+NALIASMAX+NSTBANDMAX+ISTBAND)
            ST_BAND_EFFIC(ISTBAND,IST) = 
     1        VALS(27+NALIASMAX+2*NSTBANDMAX+ISTBAND)
            ST_BAND_TSYSJY(ISTBAND,IST) = 
     1        VALS(27+NALIASMAX+3*NSTBANDMAX+ISTBAND)
          END DO
          DO IELEM=1,6
            ST_AEIOWMORB(IELEM,IST) = 
     1        VALS(27+NALIASMAX+4*NSTBANDMAX+IELEM)
          END DO
          ST_YEARORB(IST) = VALS(34+NALIASMAX+4*NSTBANDMAX)
          ST_MNTHORB(IST) = VALS(35+NALIASMAX+4*NSTBANDMAX)
          ST_DAYORB(IST)  = VALS(36+NALIASMAX+4*NSTBANDMAX)
          ST_UTORB(IST)   = VALS(37+NALIASMAX+4*NSTBANDMAX)/3600D0
          DO IELEM=1,3
            ST_TELEDIR(IELEM,IST) = 
     1        VALS(37+NALIASMAX+4*NSTBANDMAX+IELEM)
          END DO
          ST_TELANGLE(IST) = VALS(41+NALIASMAX+4*NSTBANDMAX)
          
          do i=1,NSUNAVOIDMAX
           ST_SUNAVOID(i,IST) = VALS(41+NALIASMAX+4*NSTBANDMAX+i)
          end do
          
          ST_ANTISUNAVOID(IST) = VALS(42+NALIASMAX+4*NSTBANDMAX+NSUNAVOIDMAX)
          ST_MOONAVOID(IST)    = VALS(43+NALIASMAX+4*NSTBANDMAX+NSUNAVOIDMAX)
          ST_ECLIPMULT(IST)    = VALS(44+NALIASMAX+4*NSTBANDMAX+NSUNAVOIDMAX)
          ST_ECLIPADD(IST)     = VALS(45+NALIASMAX+4*NSTBANDMAX+NSUNAVOIDMAX)
         
! convert from minutes to 1/60 s
          ST_ECLIPADD(IST)     = 60*60*ST_ECLIPADD(IST)
          
          ST_NARRAY(IST) = 0
          
          DO IARRAY=1,NARRAYMAX
            WRITE (ST_ARRAY_NAME(IARRAY,IST), '(A8)') 
     1        VALS(45+NALIASMAX+4*NSTBANDMAX+IARRAY+NSUNAVOIDMAX)
            IF (ST_ARRAY_NAME(IARRAY,IST) .EQ. ' ') GO TO 10
            CALL UPCASE(ST_ARRAY_NAME(IARRAY,IST))
            ST_NARRAY(IST) = IARRAY
          END DO
   10     CONTINUE
          DO ITAPETYPE=1,NSTTAPETYPEMAX
            WRITE (ST_TAPETYPE_NAME(ITAPETYPE,IST), '(A8)') 
     1        VALS(45+NALIASMAX+4*NSTBANDMAX+NARRAYMAX+NSUNAVOIDMAX+ITAPETYPE)
            IF (ST_TAPETYPE_NAME(ITAPETYPE,IST) .EQ. ' ') GO TO 15
            CALL UPCASE(ST_TAPETYPE_NAME(ITAPETYPE,IST))
          END DO
   15     CONTINUE
          NST = IST
          NST_IN = NST
        END DO
   20   CONTINUE
        CLOSE (UNIT=ISTUNIT)
        FIRST_TIME = .FALSE.
      END IF
C                         
      IER = 0
      STNAME_UPCASE = STNAME
      CALL UPCASE(STNAME_UPCASE)
C    VP
C      DO IST=1,NST
C        DO IALIAS=1,ST_NALIAS(IST)
C      write(*,*) 'GS_STTYPE:', ST_TYPE(IST),' IST=',IST,
C     1  ' ST_NAME(IALIAS,IST)=',ST_NAME(IALIAS,IST),'<:'
C      end  do 
C      end do
      DO IST=1,NST
        DO IALIAS=1,ST_NALIAS(IST)
          IF (ST_NAME(IALIAS,IST) .EQ. STNAME_UPCASE) THEN
            STLAT = ST_LAT(IST)
            STLONG = ST_LONG(IST)
            STHALIM = ST_HALIM(IST)
            STZALIM1 = ST_ZALIM1(IST)
            STZALIM2 = ST_ZALIM2(IST)
            STX = ST_X(IST)
            STY = ST_Y(IST)
            STZ = ST_Z(IST)
            STTYPE = ST_TYPE(IST)
C  VP 
C	    write(*,*) 'GS_STTYPE:', sttype,' IST=',IST,
C     1    ' ST_NAME(IALIAS,IST)=',ST_NAME(IALIAS,IST),'<:',
C     1    ' STNAME_UPCASE=',STNAME_UPCASE, '<:',
C     1     ' IALIAS=',IALIAS
            STDIAM = ST_DIAM(IST)
            STSLEW1 = ST_SLEW1(IST) 
            STSLEW2 = ST_SLEW2(IST)
            DO ISTBAND=1,NSTBANDMAX
              STBAND_NAME(ISTBAND) = ST_BAND_NAME(ISTBAND,IST)
              STBAND_TSYS(ISTBAND) = ST_BAND_TSYS(ISTBAND,IST)
              STBAND_EFFIC(ISTBAND) = ST_BAND_EFFIC(ISTBAND,IST)
              STBAND_TSYSJY(ISTBAND) = ST_BAND_TSYSJY(ISTBAND,IST)
            END DO
            DO IELEM=1,6
              AEIOWMORB(IELEM) = ST_AEIOWMORB(IELEM,IST)
            END DO
            YEARORB = ST_YEARORB(IST)
            MNTHORB = ST_MNTHORB(IST)
            DAYORB = ST_DAYORB(IST)
            UTORB = ST_UTORB(IST)
            DO IELEM=1,3
              TELEDIR(IELEM) = ST_TELEDIR(IELEM,IST)
            END DO
            TELANGLE = ST_TELANGLE(IST)
            
            do i=1,NSUNAVOIDMAX
             SUNAVOID(i) = ST_SUNAVOID(i,IST)
            end do
            
            ANTISUNAVOID = ST_ANTISUNAVOID(IST)
            MOONAVOID = ST_MOONAVOID(IST)
            ECLIPMULT   = ST_ECLIPMULT(IST)
            ECLIPADD    = ST_ECLIPADD(IST)
            DO IARRAY=1,NARRAYMAX
              STARRAY_NAME(IARRAY) = ST_ARRAY_NAME(IARRAY,IST)
            END DO
            STNARRAY = ST_NARRAY(IST)
            DO ITAPETYPE=1,NSTTAPETYPEMAX
              STTAPETYPE_NAME(ITAPETYPE) = 
     1          ST_TAPETYPE_NAME(ITAPETYPE,IST)
            END DO
            IER = 1
            GO TO 30
          END IF
        END DO
      END DO
   30 CONTINUE
      RETURN
      END
