C*PRFREQ -- choose frequency units
C+
      SUBROUTINE PRFREQ (FREQ, FACTOR, UNIT)
      DOUBLE PRECISION FREQ, FACTOR
      CHARACTER*(*) UNIT
C
C This routine is used when printing or formatting a numerical
C frequency. The routine chooses appropriate units so that the
C numerical value will be between 1 and 999.9...  The chosen
C units will be Hz with one of the allowed SI prefixes.
C
C Arguments:
C   FREQ   (input) : frequency in Hz
C   FACTOR (output): factor by which FREQ must be divided to convert
C                    to chosen units (e.g., 1E6)
C   UNIT   (output): name of chosen unit (e.g., 'MHz')
C
C Subroutines required:
C   None.
C
C History:
C   1988 Jul 13 - new routine [TJP].
C-----------------------------------------------------------------------
      CHARACTER*3 UNITS(13)
      DATA UNITS /'aHz', 'fHz', 'pHz', 'nHz', 'uHz', 'mHz',
     1            'Hz ', 'kHz', 'MHz', 'GHz', 'THz', 'PHz', 'EHz'/
      DOUBLE PRECISION POWER(13)
      DATA POWER /1D-18, 1D-15, 1D-12,  1D-9,  1D-6,  1D-3,
     1              1D0,   1D3,   1D6,   1D9,  1D12,  1D15,  1D18/
      INTEGER I

      IF (FREQ.EQ.0D0) THEN
          FACTOR = POWER(7)
          UNIT   = UNITS(7)
          RETURN
      END IF
      DO 10 I=2,13
          IF (ABS(FREQ) .LT. POWER(I)) THEN
              FACTOR = POWER(I-1)
              UNIT   = UNITS(I-1)
              RETURN
          END IF
   10 CONTINUE
      FACTOR = POWER(13)
      UNIT   = UNITS(13)
      RETURN
      END
